#
# Conditional build:
%bcond_without	static_libs	# static library
%bcond_without	tcmalloc	# tcmalloc usage
%bcond_without	tests		# unit tests

%ifarch x32
%undefine	with_tcmalloc
%endif
Summary:	LevelDB - key-value store library
Summary(pl.UTF-8):	LevelDB - biblioteka bazy danych klucz-wartość
Name:		leveldb
Version:	1.21
Release:	1
License:	BSD
Group:		Libraries
#Source0Download: https://github.com/google/leveldb/releases
Source0:	https://github.com/google/leveldb/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	11609dcd141584a784d879d3879f36b7
Patch0:		%{name}-soname.patch
URL:		https://github.com/google/leveldb
BuildRequires:	cmake >= 3.9
BuildRequires:	libstdc++-devel >= 6:4.7
%{?with_tcmalloc:BuildRequires:	libtcmalloc-devel}
BuildRequires:	snappy-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LevelDB is a fast key-value storage library written at Google that
provides an ordered mapping from string keys to string values.

%description -l pl.UTF-8
LevelDB to napisana w Google szybka biblioteka do przechowywania par
klucz-wartość, udostępniająca uporządkowane odwzorowanie z kluczy
będących łańcuchami znaków do wartości tego samego typu.

%package devel
Summary:	Header files for LevelDB library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki LevelDB
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libstdc++-devel >= 6:4.7
%{?with_tcmalloc:Requires: libtcmalloc-devel}
Requires:	snappy-devel

%description devel
Header files for LevelDB library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki LevelDB.

%package static
Summary:	Static LevelDB library
Summary(pl.UTF-8):	Statyczna biblioteka LevelDB
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static LevelDB library.

%description static -l pl.UTF-8
Statyczna biblioteka LevelDB.

%prep
%setup -q
%patch0 -p1

%build
%if %{with static_libs}
install -d build-static
cd build-static
%cmake .. \
	-DBUILD_SHARED_LIBS:BOOL=OFF

%{__make}
cd ..
%endif

install -d build
cd build
%cmake ..

%{__make}

%if %{with tests}
ctest
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with static_libs}
%{__make} -C build-static install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS LICENSE NEWS README.md TODO
%attr(755,root,root) %{_libdir}/libleveldb.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libleveldb.so.1

%files devel
%defattr(644,root,root,755)
%doc doc/*
%attr(755,root,root) %{_libdir}/libleveldb.so
%{_includedir}/leveldb
%{_libdir}/cmake/leveldb

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libleveldb.a
%endif
%changelog
* Fri Aug 16 2019 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/leveldb.git;a=log;h=5afc60f7bc6a4c1532f19c959c5d20de2d1e9f4f

* Sat Mar 30 2019 Jakub Bogusz <qboosh@pld-linux.org> 5afc60f
- updated to 1.21
- added soname patch to fix missing soname after build system change (cmake now)

* Fri Apr 28 2017 Jakub Bogusz <qboosh@pld-linux.org> dad93a6
- updated to 1.20

* Sun Dec 25 2016 Jakub Bogusz <qboosh@pld-linux.org> 2287b48
- updated to 1.19

* Sat Mar 26 2016 Elan Ruusamäe <glen@delfi.ee> afb564a
- run tests

* Sat Mar 26 2016 Elan Ruusamäe <glen@delfi.ee> 3b7ebd8
- up to 1.18

* Sun Nov 15 2015 Jan Rękorajski <baggins@pld-linux.org> 210efea
- release 3 (by relup.sh)

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 2f3003e
- x32 rebuild
- release 2 (by relup.sh)

* Tue Dec 30 2014 Jan Rękorajski <baggins@pld-linux.org> bcb0d92
- fix tcmalloc bcond for devel package

* Tue Dec 30 2014 Jan Rękorajski <baggins@pld-linux.org> 426abf9
- added tcmalloc bcond

* Sat Mar 08 2014 Jakub Bogusz <qboosh@pld-linux.org> e268866
- updated to 1.15.0

* Tue Oct 15 2013 Jakub Bogusz <qboosh@pld-linux.org> 0d660fc
- updated to 1.14.0

* Tue Aug 27 2013 Jakub Bogusz <qboosh@pld-linux.org> a84fa3f
- updated to 1.13.0

* Mon Jul 08 2013 Jakub Bogusz <qboosh@pld-linux.org> 3ffa640
- updated to 1.12.0

* Sun Jun 16 2013 Jakub Bogusz <qboosh@pld-linux.org> d2a9272
- updated to 1.11.0

* Mon Apr 01 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 37b02e3
- release 2 (by relup.sh)

* Wed Jan 09 2013 Jakub Bogusz <qboosh@pld-linux.org> 82aeaef
- updated to 1.9.0

* Sun Jan 06 2013 Jakub Bogusz <qboosh@pld-linux.org> 2281969
- updated to 1.8.0

* Sun Oct 21 2012 Jakub Bogusz <qboosh@pld-linux.org> 92daee1
- updated to 1.7.0
- removed obsolete soname patch

* Tue Oct 16 2012 Jakub Bogusz <qboosh@pld-linux.org> ab8ec6e
- patch to kill invalid path from SONAME

* Tue Oct 16 2012 Jakub Bogusz <qboosh@pld-linux.org> ceaf2f9
- added soname patch (remove invalid path from libleveldb SONAME)

